GeneratedMessageV3.Builder
Date: 2017-07-08

com.google.protobuf

## Class GeneratedMessageV3.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite.Builder
  - - com.google.protobuf.AbstractMessage.Builder<BuilderType>
    - - com.google.protobuf.GeneratedMessageV3.Builder<BuilderType>

- All Implemented Interfaces:
    Message.Builder, MessageLite.Builder, MessageLiteOrBuilder, MessageOrBuilder, java.lang.Cloneable
  Direct Known Subclasses:
    DescriptorProtos.DescriptorProto.Builder, DescriptorProtos.DescriptorProto.ExtensionRange.Builder, DescriptorProtos.DescriptorProto.ReservedRange.Builder, DescriptorProtos.EnumDescriptorProto.Builder, DescriptorProtos.EnumValueDescriptorProto.Builder, DescriptorProtos.FieldDescriptorProto.Builder, DescriptorProtos.FileDescriptorProto.Builder, DescriptorProtos.FileDescriptorSet.Builder, DescriptorProtos.GeneratedCodeInfo.Annotation.Builder, DescriptorProtos.GeneratedCodeInfo.Builder, DescriptorProtos.MethodDescriptorProto.Builder, DescriptorProtos.OneofDescriptorProto.Builder, DescriptorProtos.ServiceDescriptorProto.Builder, DescriptorProtos.SourceCodeInfo.Builder, DescriptorProtos.SourceCodeInfo.Location.Builder, DescriptorProtos.UninterpretedOption.Builder, DescriptorProtos.UninterpretedOption.NamePart.Builder, GeneratedMessageV3.ExtendableBuilder
  Enclosing class:
    GeneratedMessageV3

      public abstract static class GeneratedMessageV3.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>
      extends AbstractMessage.Builder<BuilderType>

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `GeneratedMessageV3.Builder()`
    `protected` | `GeneratedMessageV3.Builder(GeneratedMessageV3.BuilderParent builderParent)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `BuilderType` | `addRepeatedField(Descriptors.FieldDescriptor field, java.lang.Object value)` Like `setRepeatedField`, but appends the value as a new element.
    `BuilderType` | `clear()` Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
    `BuilderType` | `clearField(Descriptors.FieldDescriptor field)` Clears the field.
    `BuilderType` | `clearOneof(Descriptors.OneofDescriptor oneof)` TODO(jieluo): Clear it when all subclasses have implemented this method.
    `BuilderType` | `clone()` Clones the Builder.
    `java.util.Map<Descriptors.FieldDescriptor,java.lang.Object>` | `getAllFields()` Returns a collection of all the fields in this message which are set and their corresponding values.
    `Descriptors.Descriptor` | `getDescriptorForType()` Get the message's type's descriptor.
    `java.lang.Object` | `getField(Descriptors.FieldDescriptor field)` Obtains the value of the given field, or the default value if it is not set.
    `Message.Builder` | `getFieldBuilder(Descriptors.FieldDescriptor field)` Get a nested builder instance for the given field.
    `Descriptors.FieldDescriptor` | `getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)` TODO(jieluo): Clear it when all subclasses have implemented this method.
    `protected GeneratedMessageV3.BuilderParent` | `getParentForChildren()` Gets the `GeneratedMessageV3.BuilderParent` for giving to our children.
    `java.lang.Object` | `getRepeatedField(Descriptors.FieldDescriptor field, int index)` Gets an element of a repeated field.
    `Message.Builder` | `getRepeatedFieldBuilder(Descriptors.FieldDescriptor field, int index)` Get a nested builder instance for the given repeated field instance.
    `int` | `getRepeatedFieldCount(Descriptors.FieldDescriptor field)` Gets the number of elements of a repeated field.
    `UnknownFieldSet` | `getUnknownFields()` Get the `UnknownFieldSet` for this message.
    `boolean` | `hasField(Descriptors.FieldDescriptor field)` Returns true if the given field is set.
    `boolean` | `hasOneof(Descriptors.OneofDescriptor oneof)` TODO(jieluo): Clear it when all subclasses have implemented this method.
    `protected abstract GeneratedMessageV3.FieldAccessorTable` | `internalGetFieldAccessorTable()` Get the FieldAccessorTable for this type.
    `protected MapField` | `internalGetMapField(int fieldNumber)` Gets the map field with the given field number.
    `protected MapField` | `internalGetMutableMapField(int fieldNumber)` Like `internalGetMapField(int)` but return a mutable version.
    `protected boolean` | `isClean()` Gets whether invalidations are needed
    `boolean` | `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
    `protected void` | `markClean()` Called by the subclass or a builder to notify us that a message was built and may be cached and therefore invalidations are needed.
    `BuilderType` | `mergeUnknownFields(UnknownFieldSet unknownFields)` Merge some unknown fields into the `UnknownFieldSet` for this message.
    `Message.Builder` | `newBuilderForField(Descriptors.FieldDescriptor field)` Create a Builder for messages of the appropriate type for the given field.
    `protected void` | `onBuilt()` Called by the subclass when a message is built.
    `protected void` | `onChanged()` Called when a the builder or one of its nested children has changed and any parent should be notified of its invalidation.
    `protected boolean` | `parseUnknownField(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag)` Called by subclasses to parse an unknown field.
    `BuilderType` | `setField(Descriptors.FieldDescriptor field, java.lang.Object value)` Sets a field to the given value.
    `BuilderType` | `setRepeatedField(Descriptors.FieldDescriptor field, int index, java.lang.Object value)` Sets an element of a repeated field to the given value.
    `BuilderType` | `setUnknownFields(UnknownFieldSet unknownFields)` Set the `UnknownFieldSet` for this message.

    - ### Methods inherited from class com.google.protobuf.AbstractMessage.Builder

      `findInitializationErrors, getInitializationErrorString, internalMergeFrom, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, newUninitializedMessageException, toString`

    - ### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

      `addAll, mergeFrom, newUninitializedMessageException`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.Message.Builder

      `build, buildPartial`

    - ### Methods inherited from interface com.google.protobuf.MessageLite.Builder

      `mergeFrom`

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `getDefaultInstanceForType`

- - ### Constructor Detail

    - #### GeneratedMessageV3.Builder

          protected GeneratedMessageV3.Builder()

    - #### GeneratedMessageV3.Builder

          protected GeneratedMessageV3.Builder(GeneratedMessageV3.BuilderParent builderParent)

  - ### Method Detail

    - #### onBuilt

          protected void onBuilt()

      Called by the subclass when a message is built.

    - #### markClean

          protected void markClean()

      Called by the subclass or a builder to notify us that a message was built and may be cached and therefore invalidations are needed.

    - #### isClean

          protected boolean isClean()

      Gets whether invalidations are needed
      Returns:
        whether invalidations are needed

    - #### clone

          public BuilderType clone()

      Description copied from interface: `MessageLite.Builder`
      Clones the Builder.
      Specified by:
        `clone` in interface `Message.Builder`
      Specified by:
        `clone` in interface `MessageLite.Builder`
      Overrides:
        `clone` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`
      See Also:
        `Object.clone()`

    - #### clear

          public BuilderType clear()

      Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
      Specified by:
        `clear` in interface `Message.Builder`
      Specified by:
        `clear` in interface `MessageLite.Builder`
      Overrides:
        `clear` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`

    - #### internalGetFieldAccessorTable

          protected abstract GeneratedMessageV3.FieldAccessorTable internalGetFieldAccessorTable()

      Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

    - #### getDescriptorForType

          public Descriptors.Descriptor getDescriptorForType()

      Description copied from interface: `Message.Builder`
      Get the message's type's descriptor. See `MessageOrBuilder.getDescriptorForType()`.

    - #### getAllFields

          public java.util.Map<Descriptors.FieldDescriptor,java.lang.Object> getAllFields()

      Description copied from interface: `MessageOrBuilder`
      Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.
      If this is for a builder, the returned map may or may not reflect future changes to the builder. Either way, the returned map is itself unmodifiable.

    - #### newBuilderForField

          public Message.Builder newBuilderForField(Descriptors.FieldDescriptor field)

      Description copied from interface: `Message.Builder`
      Create a Builder for messages of the appropriate type for the given field. Messages built with this can then be passed to setField(), setRepeatedField(), or addRepeatedField().

    - #### getFieldBuilder

          public Message.Builder getFieldBuilder(Descriptors.FieldDescriptor field)

      Description copied from interface: `Message.Builder`
      Get a nested builder instance for the given field.

      Normally, we hold a reference to the immutable message object for the message type field. Some implementations(the generated message builders), however, can also hold a reference to the builder object (a nested builder) for the field.

      If the field is already backed up by a nested builder, the nested builder will be returned. Otherwise, a new field builder will be created and returned. The original message field (if exist) will be merged into the field builder, which will then be nested into its parent builder.

      NOTE: implementations that do not support nested builders will throw `UnsupportedOperationException`.

      Specified by:
        `getFieldBuilder` in interface `Message.Builder`
      Overrides:
        `getFieldBuilder` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`

    - #### getRepeatedFieldBuilder

          public Message.Builder getRepeatedFieldBuilder(Descriptors.FieldDescriptor field,
                                                int index)

      Description copied from interface: `Message.Builder`
      Get a nested builder instance for the given repeated field instance.

      Normally, we hold a reference to the immutable message object for the message type field. Some implementations(the generated message builders), however, can also hold a reference to the builder object (a nested builder) for the field.

      If the field is already backed up by a nested builder, the nested builder will be returned. Otherwise, a new field builder will be created and returned. The original message field (if exist) will be merged into the field builder, which will then be nested into its parent builder.

      NOTE: implementations that do not support nested builders will throw `UnsupportedOperationException`.

      Specified by:
        `getRepeatedFieldBuilder` in interface `Message.Builder`
      Overrides:
        `getRepeatedFieldBuilder` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`

    - #### hasOneof

          public boolean hasOneof(Descriptors.OneofDescriptor oneof)

      Description copied from class: `AbstractMessage.Builder`
      TODO(jieluo): Clear it when all subclasses have implemented this method.
      Specified by:
        `hasOneof` in interface `MessageOrBuilder`
      Overrides:
        `hasOneof` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`

    - #### getOneofFieldDescriptor

          public Descriptors.FieldDescriptor getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)

      Description copied from class: `AbstractMessage.Builder`
      TODO(jieluo): Clear it when all subclasses have implemented this method.
      Specified by:
        `getOneofFieldDescriptor` in interface `MessageOrBuilder`
      Overrides:
        `getOneofFieldDescriptor` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`

    - #### hasField

          public boolean hasField(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Returns true if the given field is set. This is exactly equivalent to calling the generated "has" accessor method corresponding to the field.

    - #### getField

          public java.lang.Object getField(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Obtains the value of the given field, or the default value if it is not set. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned. For repeated fields, a java.util.List is returned.

    - #### setField

          public BuilderType setField(Descriptors.FieldDescriptor field,
                             java.lang.Object value)

      Description copied from interface: `Message.Builder`
      Sets a field to the given value. The value must be of the correct type for this field, i.e. the same type that `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` would return.

    - #### clearField

          public BuilderType clearField(Descriptors.FieldDescriptor field)

      Description copied from interface: `Message.Builder`
      Clears the field. This is exactly equivalent to calling the generated "clear" accessor method corresponding to the field.

    - #### clearOneof

          public BuilderType clearOneof(Descriptors.OneofDescriptor oneof)

      Description copied from class: `AbstractMessage.Builder`
      TODO(jieluo): Clear it when all subclasses have implemented this method.
      Specified by:
        `clearOneof` in interface `Message.Builder`
      Overrides:
        `clearOneof` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`

    - #### getRepeatedFieldCount

          public int getRepeatedFieldCount(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Gets the number of elements of a repeated field. This is exactly equivalent to calling the generated "Count" accessor method corresponding to the field.

    - #### getRepeatedField

          public java.lang.Object getRepeatedField(Descriptors.FieldDescriptor field,
                                          int index)

      Description copied from interface: `MessageOrBuilder`
      Gets an element of a repeated field. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned.

    - #### setRepeatedField

          public BuilderType setRepeatedField(Descriptors.FieldDescriptor field,
                                     int index,
                                     java.lang.Object value)

      Description copied from interface: `Message.Builder`
      Sets an element of a repeated field to the given value. The value must be of the correct type for this field, i.e. the same type that `MessageOrBuilder.getRepeatedField(Descriptors.FieldDescriptor,int)` would return.

    - #### addRepeatedField

          public BuilderType addRepeatedField(Descriptors.FieldDescriptor field,
                                     java.lang.Object value)

      Description copied from interface: `Message.Builder`
      Like `setRepeatedField`, but appends the value as a new element.

    - #### setUnknownFields

          public BuilderType setUnknownFields(UnknownFieldSet unknownFields)

      Description copied from interface: `Message.Builder`
      Set the `UnknownFieldSet` for this message.

    - #### mergeUnknownFields

          public BuilderType mergeUnknownFields(UnknownFieldSet unknownFields)

      Description copied from interface: `Message.Builder`
      Merge some unknown fields into the `UnknownFieldSet` for this message.
      Specified by:
        `mergeUnknownFields` in interface `Message.Builder`
      Overrides:
        `mergeUnknownFields` in class `AbstractMessage.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>`

    - #### isInitialized

          public boolean isInitialized()

      Description copied from interface: `MessageLiteOrBuilder`
      Returns true if all required fields in the message and all embedded messages are set, false otherwise.

      See also: `MessageOrBuilder.getInitializationErrorString()`

    - #### getUnknownFields

          public final UnknownFieldSet getUnknownFields()

      Description copied from interface: `MessageOrBuilder`
      Get the `UnknownFieldSet` for this message.

    - #### parseUnknownField

          protected boolean parseUnknownField(CodedInputStream input,
                                  UnknownFieldSet.Builder unknownFields,
                                  ExtensionRegistryLite extensionRegistry,
                                  int tag)
                                       throws java.io.IOException

      Called by subclasses to parse an unknown field.
      Returns:
        `true` unless the tag is an end-group tag.
      Throws:
        `java.io.IOException`

    - #### getParentForChildren

          protected GeneratedMessageV3.BuilderParent getParentForChildren()

      Gets the `GeneratedMessageV3.BuilderParent` for giving to our children.
      Returns:
        The builder parent for our children.

    - #### onChanged

          protected final void onChanged()

      Called when a the builder or one of its nested children has changed and any parent should be notified of its invalidation.

    - #### internalGetMapField

          protected MapField internalGetMapField(int fieldNumber)

      Gets the map field with the given field number. This method should be overridden in the generated message class if the message contains map fields. Unlike other field types, reflection support for map fields can't be implemented based on generated public API because we need to access a map field as a list in reflection API but the generated API only allows us to access it as a map. This method returns the underlying map field directly and thus enables us to access the map field as a list.

    - #### internalGetMutableMapField

          protected MapField internalGetMutableMapField(int fieldNumber)

      Like `internalGetMapField(int)` but return a mutable version.